
;********************************************************************************;
;                                InveertBits                                     ;
;********************************************************************************;
;                                                                                ;
; Description:                                                                   ;
;  The program inverting bits of binary number.                                  ;
;                                                                                ;
; Target OS:                                                                     ;
;  Windows.                                                                      ;
;                                                                                ;
; The code is written by Vermut.                                                 ;
; Created specially for http://forum.shelek.ru/                                  ;
; Compile with FASM.                                                             ;
;                                                                                ;
; Rights of copying: is free.                                                    ;
;                                                                                ;
;********************************************************************************;

;--------------------------------------------------------------------------------;
; HEAD AREA                                                                      ;
;--------------------------------------------------------------------------------;

format PE GUI 4.0
entry START

include 'C:\Program Files\FASM\INCLUDE\win32ax.inc'

;--------------------------------------------------------------------------------;
; CODE AREA                                                                      ;
;--------------------------------------------------------------------------------;

START:
	xor	eax, eax
	mov	 al, bin_number
        mov     edi, Result.highword
	call	CnvByteToASCIIBinNumber
	not	 al
        mov     edi, Result.lowword
	call	CnvByteToASCIIBinNumber
	invoke	MessageBox, 0, Result, Caption, 0
        invoke	ExitProcess, 0

;--------------------------------------------------------------------------------;
; PROCS AREA                                                                     ;
;--------------------------------------------------------------------------------;

; al  = byte number.
; edi = buffer address.

CnvByteToASCIIBinNumber:
	xor	ecx, ecx
        mov     cl, 8
    cnv:
        rol     al, 1
        jc      set_1
	mov	[edi], byte "0"
        jmp     @f
  set_1:
        mov     [edi], byte "1"
  @@:
        inc     edi
	dec	cl
	jnz	cnv
	clc
	ret

;--------------------------------------------------------------------------------;
; DATA AREA                                                                      ;
;--------------------------------------------------------------------------------;

Caption: db 'Inverting bits example!', 0

bin_number = 10100010b

virtual at Result
end virtual

Result:
db 'HighWord: '
.highword: db '        b', 10, 13
db 'LowWord:  '
.lowword:  db '        b ', 0

;--------------------------------------------------------------------------------;
; IMPORT AREA                                                                    ;
;--------------------------------------------------------------------------------;

data import

  library KERNEL32, 'KERNEL32.DLL',\
          USER32, 'USER32.DLL'

  import KERNEL32,\
  ExitProcess, 'ExitProcess'

  import USER32,\
  MessageBox, 'MessageBoxA'

end data

;--------------------------------------------------------------------------------;


